You can configure the PivotTable with different parameters:
These parameters that can be used for PivotTable are as follows:
allowMultipleFiltersPerField: whether multiple filters can be used in one field.
insertBlankLineAfterEachItem: whether a blank row should be inserted at end of each item.
grandTotalPosition: show the grandtotal in the row, column or both.
subtotalsPosition: show subtotal top, bottom, or not.
displayFieldsInPageFilterArea: display the page area fields first over then down or first down then over
reportFilterFieldsPerColumn: the number of report filter fields per column
bandRows: show banded rows or not
bandColumns: show banded columns or not
showRowHeader: show row header styles or not
showColumnHeader: show column header styles or not
showDrill: show expand/collapse button or not
showMissing: show missing caption or not
showToolTip: show tool tip or not
missingCaption: replace empty cell in content area to custom string or number
fillDownLabels: show repeat label items or not
repeatAllItemLabels: show repeat label items or not
rowLabelIndent: set the indent of each level of title in compact layout
mergeItem: merge and center cells with labels
showHeaders: show row and column headers or not
window.onload = function () {
let spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), {sheetCount: 2});
initSpread(spread);
};
function initSpread(spread) {
spread.suspendPaint();
let sheet1 = spread.getSheet(0);
let sheet2 = spread.getSheet(1);
let tableName = getDataSource(sheet2, pivotSales);
let pivotTable = initPivotTable(sheet1, tableName);
bindEvent(pivotTable, spread);
spread.resumePaint();
}
function getDataSource(sheet, tableSource){
sheet.name("DataSource");
sheet.setRowCount(117);
sheet.setColumnWidth(0, 120);
sheet.getCell(-1, 0).formatter("YYYY-mm-DD");
sheet.getRange(-1,4,0,2).formatter("$ #,##0");
let table = sheet.tables.add('table', 0, 0, 117, 6);
for(let i=2;i<=117;i++)
{
sheet.setFormula(i-1,5,'=D'+i+'*E'+i)
}
table.style(GC.Spread.Sheets.Tables.TableThemes["none"]);
sheet.setArray(0, 0, tableSource);
return table.name();
}
function initPivotTable(sheet, source){
sheet.name("PivotTable");
sheet.setRowCount(1000);
let option = {
showRowHeader:true,
showColumnHeader:true,
bandRows:true,
bandColumns:true
};
let pivotTable = sheet.pivotTables.add("pivotTable", source, 1, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.medium8,option);
pivotTable.suspendLayout();
pivotTable.add("quantity", "Quantity", GC.Spread.Pivot.PivotTableFieldType.filterField);
pivotTable.add("price", "Price", GC.Spread.Pivot.PivotTableFieldType.filterField);
pivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField);
pivotTable.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.rowField);
let groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] };
pivotTable.group(groupInfo);
pivotTable.add("Quarters (date)", "Quarters (date)", GC.Spread.Pivot.PivotTableFieldType.columnField);
pivotTable.add("total", "Totals", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
let style = new GC.Spread.Sheets.Style();
style.formatter = "$ #,##0";
pivotTable.setStyle({dataOnly: true}, style);
pivotTable.resumeLayout();
pivotTable.autoFitColumn();
return pivotTable;
}
function bindEvent(pivotTable){
document.getElementById("set-option").addEventListener("click", function(event){
pivotTable.suspendLayout();
let radioOption = document.getElementsByClassName("select-option");
let option = pivotTable.options, item;
for (let i = 0; i < radioOption.length; i++) {
item = radioOption[i];
option[item.value] = item.checked;
}
let grandTotalPosition = document.getElementById("grandTotalPosition");
option["grandTotalPosition"] = GC.Spread.Pivot.GrandTotalPosition[grandTotalPosition.options[grandTotalPosition.selectedIndex].text];
let subtotalsPosition = document.getElementById("subtotalsPosition");
option["subTotalsPosition"] = GC.Spread.Pivot.SubtotalsPosition[subtotalsPosition.options[subtotalsPosition.selectedIndex].text];
let displayFields = document.getElementById("displayFieldsInPageFilterArea");
option["displayFieldsInPageFilterArea"] = GC.Spread.Pivot.DisplayFields[displayFields.options[displayFields.selectedIndex].text];
let reportFilterFieldsPerColumn = document.getElementById("reportFilterFieldsPerColumn");
option["reportFilterFieldsPerColumn"] = +reportFilterFieldsPerColumn.value;
let missingCaption = document.getElementById("missingCaption");
if (!isNaN(parseFloat(missingCaption.value))) {
option["missingCaption"] = parseFloat(missingCaption.value);
} else {
option["missingCaption"] = missingCaption.value;
}
let rowLabelIndent = document.getElementById('rowLabelIndent');
if (!isNaN(parseFloat(rowLabelIndent.value))) {
option["rowLabelIndent"] = parseFloat(rowLabelIndent.value);
}
pivotTable.layoutType(+document.getElementById("pivotTableLayout").value);
pivotTable.resumeLayout();
});
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-shapes/dist/gc.spread.sheets.shapes.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-pivot-addon/dist/gc.spread.pivot.pivottables.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script>
<script src="app.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="styles.css">
</head>
<body>
<div class="sample-tutorial">
<div id="ss" class="sample-spreadsheets"></div>
<div id="container" class="options-container">
<div class="option-item">
<label><b>Pivot Options</b></label>
</div>
<hr>
<div class="option-item">
<input type="checkbox" id="allowMultipleFiltersPerField" name="allowMultipleFiltersPerField" value="allowMultipleFiltersPerField" class="select-option">
<label for="allowMultipleFiltersPerField">Allow Multiple Filters Per Field</label>
</div>
<div class="option-item">
<input type="checkbox" id="insertBlankLineAfterEachItem" name="insertBlankLineAfterEachItem" value="insertBlankLineAfterEachItem" class="select-option">
<label for="insertBlankLineAfterEachItem">Insert Blank Line After Each Item</label>
</div>
<div class="option-item">
<input type="checkbox" id="fillDownLabels" name="fillDownLabels" value="fillDownLabels" class="select-option">
<label for="fillDownLabels">fillDownLabels</label>
</div>
<div class="option-item">
<input type="checkbox" id="bandRows" name="bandRows" value="bandRows" class="select-option" checked>
<label for="bandRows">Band Rows</label>
</div>
<div class="option-item">
<input type="checkbox" id="bandColumns" name="bandColumns" value="bandColumns" class="select-option" checked>
<label for="bandColumns">Band Columns</label>
</div>
<div class="option-item">
<input type="checkbox" id="showRowHeader" name="showRowHeader" value="showRowHeader" class="select-option" checked>
<label for="showRowHeader">Show Row Header</label>
</div>
<div class="option-item">
<input type="checkbox" id="showColumnHeader" name="showColumnHeader" value="showColumnHeader" class="select-option" checked>
<label for="showColumnHeader">Show Column Header</label>
</div>
<div class="option-item">
<input type="checkbox" id="showDrill" name="showDrill" value="showDrill" class="select-option" checked>
<label for="showDrill">Show Drill</label>
</div>
<div class="option-item">
<input type="checkbox" id="showFilter" name="showFilter" value="showFilter" class="select-option" checked>
<label for="showFilter">Show Filter</label>
</div>
<div class="option-item">
<input type="checkbox" id="showMissing" name="showMissing" value="showMissing" class="select-option" checked>
<label for="showMissing">Show Missing</label>
</div>
<div class="option-item">
<input type="checkbox" id="showToolTip" name="showToolTip" value="showToolTip" class="select-option" checked>
<label for="showToolTip">Show Tooltip</label>
</div>
<div class="option-item">
<input type="checkbox" id="mergeItem" name="mergeItem" value="mergeItem" class="select-option">
<label for="mergeItem">Merge Item</label>
</div>
<div class="option-item">
<input type="checkbox" id="showHeaders" name="showHeaders" value="showHeaders" class="select-option" checked>
<label for="showHeaders">showHeaders</label>
</div>
<hr>
<div>
<div class = "select-option-class">Grand Total Position:</div>
<select name="" id="grandTotalPosition" class="grandTotalPosition select-option-select">
<option value="both">both</option>
<option value="none">none</option>
<option value="row">row</option>
<option value="col">col</option>
</select>
</div>
<div>
<div class = "select-option-class">Subtotals Position:</div>
<select name="" id="subtotalsPosition" class="subtotalsPosition select-option-select">
<option value="bottom">bottom</option>
<option value="none">none</option>
<option value="top">top</option>
</select>
</div>
<div>
<div class = "select-option-class">Display Fields In Page Filter Area:</div>
<select name="" id="displayFieldsInPageFilterArea" class="displayFieldsInPageFilterArea select-option-select">
<option value="overThenDown">overThenDown</option>
<option value="downThenOver">downThenOver</option>
</select>
</div>
<div>
<div class="select-option-class">PivotTable Layout:</div>
<select id="pivotTableLayout" class="pivotTableLayout select-option-select">
<option value = 0>Compact</option>
<option value = 1 selected>Outline</option>
<option value = 2>Tabular</option>
</select>
</div>
<div>
<div class = "select-option-class">Show Empty Value In Content Area As:</div>
<input type="text" name="" id="missingCaption" class="missingCaption select-option-select"/>
</div>
<div>
<div class = "select-option-class">Set Row Label Indent In Compact Layout:</div>
<input type="number" name="" id="rowLabelIndent" class="rowLabelIndent select-option-select"/>
</div>
<div>
<label for="reportFilterFieldsPerColumn">Report Filter Fields Per Column:</label>
<input type="number" value="1" id="reportFilterFieldsPerColumn" min="1">
</div>
<input type="button" value="Apply" class="set-option" id="set-option">
</div>
</div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 300px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 300px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
.set-option {
display: block;
margin-top: 20px;
width: 250px;
}
#reportFilterFieldsPerColumn {
width: 28px;
}
.select-option-class{
display: block;
margin-top: 20px;
margin-bottom: 10px
}
.select-option-select{
width: 250px;
display: block;
margin-bottom: 20px;
}
.option-item{
height: 20px;
margin-bottom: 10px;
}

You can configure the PivotTable with different parameters:
These parameters that can be used for PivotTable are as follows:
allowMultipleFiltersPerField: whether multiple filters can be used in one field.
insertBlankLineAfterEachItem: whether a blank row should be inserted at end of each item.
grandTotalPosition: show the grandtotal in the row, column or both.
subtotalsPosition: show subtotal top, bottom, or not.
displayFieldsInPageFilterArea: display the page area fields first over then down or first down then over
reportFilterFieldsPerColumn: the number of report filter fields per column
bandRows: show banded rows or not
bandColumns: show banded columns or not
showRowHeader: show row header styles or not
showColumnHeader: show column header styles or not
showDrill: show expand/collapse button or not
showMissing: show missing caption or not
showToolTip: show tool tip or not
missingCaption: replace empty cell in content area to custom string or number
fillDownLabels: show repeat label items or not
repeatAllItemLabels: show repeat label items or not
rowLabelIndent: set the indent of each level of title in compact layout
mergeItem: merge and center cells with labels
showHeaders: show row and column headers or not
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import { FormsModule } from '@angular/forms';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-pivot-addon";
import './styles.css';
const options = [
"allowMultipleFiltersPerField",
"insertBlankLineAfterEachItem",
"fillDownLabels",
"bandRows",
"bandColumns",
"showRowHeader",
"showColumnHeader",
"showDrill",
"showFilter",
"showMissing",
"showToolTip",
"mergeItem",
"showHeaders"
];
let actualOptions = {
allowMultipleFiltersPerField: false,
insertBlankLineAfterEachItem: false,
fillDownLabels: false,
bandRows: true,
bandColumns: true,
showRowHeader: true,
showColumnHeader: true,
showDrill: true,
showFilter: true,
showMissing: true,
showToolTip: true,
mergeItem:false,
showHeaders: true
};
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
autoGenerateColumns = false;
autoMergeMode = GC.Spread.Sheets.AutoMerge.AutoMergeMode.restricted;
autoMergeSelectionMode = GC.Spread.Sheets.AutoMerge.SelectionMode.merged;
dataSource: any[];
spread: GC.Spread.Sheets.Workbook;
pivotTable: any;
options = options;
actualOptions = actualOptions;
grandTotalPosition = 3;
displayFieldsInPageFilterArea = 1;
subtotalsPosition = 2;
pivotTableLayout = 1;
missingCaption: any;
reportFilterFieldsPerColumn = 1;
rowLabelIndent: any;
hostStyle = {
width: 'calc(100% - 300px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
constructor() {
}
initSpread($Event: any) {
let spread = $Event.spread;
this.spread = spread;
spread.suspendPaint();
spread.setSheetCount(2);
let sheet1 = spread.getSheet(0);
let sheet2 = spread.getSheet(1);
let tableName = this.getDataSource(sheet2, pivotSales);
let pivotTable = this.initPivotTable(sheet1, tableName);
this.pivotTable = pivotTable;
spread.resumePaint();
}
getDataSource(sheet: GC.Spread.Sheets.Workbook, tableSource: any) {
sheet.name("DataSource");
sheet.setRowCount(117);
sheet.setColumnWidth(0, 120);
sheet.getCell(-1, 0).formatter("YYYY-mm-DD");
sheet.getRange(-1,4,0,2).formatter("$ #,##0");
let table = sheet.tables.add('table', 0, 0, 117, 6);
for(let i=2;i<=117;i++)
{
sheet.setFormula(i-1,5,'=D'+i+'*E'+i)
}
table.style(GC.Spread.Sheets.Tables.TableThemes["none"]);
sheet.setArray(0, 0, tableSource);
return table.name();
}
initPivotTable(sheet: GC.Spread.Sheets.Workbook, source: any) {
sheet.name("PivotTable");
sheet.setRowCount(1000);
let option = {
showRowHeader:true,
showColumnHeader:true,
bandRows:true,
bandColumns:true
};
let pivotTable = sheet.pivotTables.add("pivotTable", source, 1, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.medium8,option);
pivotTable.suspendLayout();
pivotTable.add("quantity", "Quantity", GC.Spread.Pivot.PivotTableFieldType.filterField);
pivotTable.add("price", "Price", GC.Spread.Pivot.PivotTableFieldType.filterField);
pivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField);
pivotTable.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.rowField);
let groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] };
pivotTable.group(groupInfo);
pivotTable.add("Quarters (date)", "Quarters (date)", GC.Spread.Pivot.PivotTableFieldType.columnField);
pivotTable.add("total", "Totals", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
let style = new GC.Spread.Sheets.Style();
style.formatter = "$ #,##0";
pivotTable.setStyle({dataOnly: true}, style);
pivotTable.resumeLayout();
pivotTable.autoFitColumn();
return pivotTable;
}
setPivotOption () {
let spread = this.spread;
let pivotTable = this.pivotTable;
spread.suspendPaint();
pivotTable.suspendLayout();
let actualOption = this.actualOptions;
let option = pivotTable.options, item;
for (item in actualOption) {
if (Object.prototype.hasOwnProperty.call(actualOption, item)) {
option[item] = actualOption[item];
}
}
option["grandTotalPosition"] = +this.grandTotalPosition;
option["subtotalsPosition"] = +this.subtotalsPosition;
option["displayFieldsInPageFilterArea"] = +this.displayFieldsInPageFilterArea;
option["reportFilterFieldsPerColumn"] = +this.reportFilterFieldsPerColumn;
let rowLabelIndent = this.rowLabelIndent;
let missingCaption = this.missingCaption;
option["missingCaption"] = this.missingCaption;
if (!isNaN(parseFloat(missingCaption))) {
option["missingCaption"] = parseFloat(missingCaption);
} else {
option["missingCaption"] = missingCaption;
}
if (!isNaN(parseFloat(rowLabelIndent))) {
option["rowLabelIndent"] = parseFloat(rowLabelIndent);
}
pivotTable.layoutType(+this.pivotTableLayout);
pivotTable.resumeLayout();
spread.resumePaint();
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule, FormsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script>
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
</gc-spread-sheets>
<div id="container" class="options-container">
<div class="option-item">
<label><b>Pivot Options</b></label>
</div>
<hr>
<div class="option-item">
<input type="checkbox" id="options[0]" name="options[0]" [(ngModel)]="actualOptions[options[0]]" class="select-option">
<label for="options[0]">Allow Multiple Filters Per Field</label>
</div>
<div class="option-item">
<input type="checkbox" id="options[1]" name="options[1]" [(ngModel)]="actualOptions[options[1]]" class="select-option">
<label for="options[1]">Insert Blank Line After Each Item</label>
</div>
<div class="option-item">
<input type="checkbox" id="options[2]" name="options[2]" [(ngModel)]="actualOptions[options[2]]" class="select-option">
<label for="options[2]">fillDownLabels</label>
</div>
<div class="option-item">
<input type="checkbox" id="options[3]" name="options[3]" [(ngModel)]="actualOptions[options[3]]" class="select-option">
<label for="options[3]">Band Rows</label>
</div>
<div class="option-item">
<input type="checkbox" id="options[4]" name="options[4]" [(ngModel)]="actualOptions[options[4]]" class="select-option">
<label for="options[4]">Band Columns</label>
</div>
<div class="option-item">
<input type="checkbox" id="options[5]" name="options[5]" [(ngModel)]="actualOptions[options[5]]" class="select-option">
<label for="options[5]">Show Row Header</label>
</div>
<div class="option-item">
<input type="checkbox" id="options[6]" name="options[6]" [(ngModel)]="actualOptions[options[6]]" class="select-option">
<label for="options[6]">Show Column Header</label>
</div>
<div class="option-item">
<input type="checkbox" id="options[7]" name="options[7]" [(ngModel)]="actualOptions[options[7]]" class="select-option">
<label for="options[7]">Show Drill</label>
</div>
<div class="option-item">
<input type="checkbox" id="options[8]" name="options[8]" [(ngModel)]="actualOptions[options[8]]" class="select-option">
<label for="options[8]">show Filter</label>
</div>
<div class="option-item">
<input type="checkbox" id="options[9]" name="options[9]" [(ngModel)]="actualOptions[options[9]]" class="select-option">
<label for="options[9]">Show Missing</label>
</div>
<div class="option-item">
<input type="checkbox" id="options[10]" name="options[10]" [(ngModel)]="actualOptions[options[10]]" class="select-option">
<label for="options[10]">Show Tooltip</label>
</div>
<div class="option-item">
<input type="checkbox" id="options[11]" name="options[11]" [(ngModel)]="actualOptions[options[11]]" class="select-option">
<label for="options[11]">Merge Item</label>
</div>
<div class="option-item">
<input type="checkbox" id="options[12]" name="options[12]" [(ngModel)]="actualOptions[options[12]]" class="select-option">
<label for="options[12]">showHeaders</label>
</div>
<hr>
<div>
<div class = "select-option-class">Grand Total Position:</div>
<select name="" id="grandTotalPosition" class="grandTotalPosition select-option-select" [(ngModel)]="grandTotalPosition">
<option value="3">both</option>
<option value="0">none</option>
<option value="1">row</option>
<option value="2">col</option>
</select>
</div>
<div>
<div class = "select-option-class">Subtotals Position:</div>
<select name="" id="subtotalsPosition" class="subtotalsPosition select-option-select" [(ngModel)]="subtotalsPosition">
<option value="2">bottom</option>
<option value="0">none</option>
<option value="1">top</option>
</select>
</div>
<div>
<div class = "select-option-class">Display Fields In Page Filter Area:</div>
<select name="" id="displayFieldsInPageFilterArea" class="displayFieldsInPageFilterArea select-option-select" [(ngModel)]="displayFieldsInPageFilterArea">
<option value="1">overThenDown</option>
<option value="0">downThenOver</option>
</select>
</div>
<div>
<div class="select-option-class">PivotTable Layout:</div>
<select id="pivotTableLayout" class="pivotTableLayout select-option-select" [(ngModel)]="pivotTableLayout">
<option value = 0>Compact</option>
<option value = 1>Outline</option>
<option value = 2>Tabular</option>
</select>
</div>
<div>
<div class = "select-option-class">Show Empty Value In Content Area As:</div>
<input type="text" name="" id="missingCaption" class="missingCaption select-option-select" [(ngModel)]="missingCaption"/>
</div>
<div>
<div class = "select-option-class">Set Row Label Indent In Compact Layout:</div>
<input type="number" name="" id="rowLabelIndent" class="rowLabelIndent select-option-select" [(ngModel)]="rowLabelIndent"/>
</div>
<div>
<label for="reportFilterFieldsPerColumn">Report Filter Fields Per Column:</label>
<input type="number" id="reportFilterFieldsPerColumn" min="1" [(ngModel)]="reportFilterFieldsPerColumn">
</div>
<input type="button" value="Apply" class="set-option" id="set-option" (click)="setPivotOption()">
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 300px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 300px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
.set-option {
display: block;
margin-top: 20px;
width: 250px;
}
#reportFilterFieldsPerColumn {
width: 28px;
}
.select-option-class{
display: block;
margin-top: 20px;
margin-bottom: 10px
}
.select-option-select{
width: 250px;
display: block;
margin-bottom: 20px;
}
.option-item{
height: 20px;
margin-bottom: 10px;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-pivot-addon': 'npm:@mescius/spread-sheets-pivot-addon/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

You can configure the PivotTable with different parameters:
These parameters that can be used for PivotTable are as follows:
allowMultipleFiltersPerField: whether multiple filters can be used in one field.
insertBlankLineAfterEachItem: whether a blank row should be inserted at end of each item.
grandTotalPosition: show the grandtotal in the row, column or both.
subtotalsPosition: show subtotal top, bottom, or not.
displayFieldsInPageFilterArea: display the page area fields first over then down or first down then over
reportFilterFieldsPerColumn: the number of report filter fields per column
bandRows: show banded rows or not
bandColumns: show banded columns or not
showRowHeader: show row header styles or not
showColumnHeader: show column header styles or not
showDrill: show expand/collapse button or not
showMissing: show missing caption or not
showToolTip: show tool tip or not
missingCaption: replace empty cell in content area to custom string or number
fillDownLabels: show repeat label items or not
repeatAllItemLabels: show repeat label items or not
rowLabelIndent: set the indent of each level of title in compact layout
mergeItem: merge and center cells with labels
showHeaders: show row and column headers or not
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread"> </gc-spread-sheets>
<div id="container" class="options-container">
<div class="option-item">
<label><b>Pivot Options</b></label>
</div>
<hr>
<div class='option-item' v-for="item in items" :key="item.id">
<input type="checkbox" :name='item.name' class="select-option" v-model.lazy='item.checked'/>
<label :for='item.id'>{{item.text}}</label>
</div>
<hr>
<div>
<div class="select-option-class">Grand Total Position:</div>
<select name="" id="grandTotalPosition" class="grandTotalPosition select-option-select" v-model.number="grandTotalPosition">
<option value = 3>both</option>
<option value = 0>none</option>
<option value = 1>row</option>
<option value = 2>col</option>
</select>
</div>
<div>
<div class="select-option-class">Subtotals Position:</div>
<select id="subtotalsPosition" class="subtotalsPosition select-option-select" v-model.number="subtotalsPosition">
<option value = 2>bottom</option>
<option value = 0>none</option>
<option value = 1>top</option>
</select>
</div>
<div>
<div class="select-option-class">Display Fields In Page Filter Area:</div>
<select id="displayFieldsInPageFilterArea" class="displayFieldsInPageFilterArea select-option-select" v-model.number="displayFieldsInPageFilterArea">
<option value = 1>overThenDown</option>
<option value = 0>downThenOver</option>
</select>
</div>
<div>
<div class="select-option-class">PivotTable Layout:</div>
<select id="pivotTableLayout" class="pivotTableLayout select-option-select" v-model.number="pivotTableLayout">
<option value = 0>Compact</option>
<option value = 1>Outline</option>
<option value = 2>Tabular</option>
</select>
</div>
<div>
<div class="select-option-class">Show Empty Value In Content Area As:</div>
<input type="text" id="missingCaption" class="missingCaption select-option-select" v-model="missingCaption"/>
</div>
<div>
<div class="select-option-class">Set Row Label Indent In Compact Layout:</div>
<input type="number" id="rowLabelIndent" class="rowLabelIndent select-option-select" v-model.number="rowLabelIndent"/>
</div>
<div>
<label for="reportFilterFieldsPerColumn">Report Filter Fields Per Column:</label>
<input type="number" value="1" id="reportFilterFieldsPerColumn" min="1" v-model="reportFilterFieldsPerColumn"/>
</div>
<input type="button" value="Apply" class="set-option" id="set-option" @click="updatePivotOption"/>
</div>
</div>
</template>
<script>
import GC from "@mescius/spread-sheets";
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-vue";
import { shallowRef } from "vue";
import "@mescius/spread-sheets-pivot-addon";
export default {
name: 'App',
setup() {
const spreadRef = shallowRef(null);
const items = shallowRef([{
id:"allowMultipleFiltersPerField",
name:"allowMultipleFiltersPerField",
text:"Allow Multiple Filters Per Field",
checked:false
},{
id:"insertBlankLineAfterEachItem",
name:"insertBlankLineAfterEachItem",
text:"Insert Blank Line After Each Item",
checked:false
},{
id:"fillDownLabels",
name:"fillDownLabels",
text:"Fill Down Labels",
checked:false
},{
id:"bandRows",
name:"bandRows",
text:"Band Rows",
checked:true
},{
id:"bandColumns",
name:"bandColumns",
text:"Band Columns",
checked:true
},{
id:"showRowHeader",
name:"showRowHeader",
text:"Show Row Header",
checked:true
},{
id:"showColumnHeader",
name:"showColumnHeader",
text:"Show Column Header",
checked:true
},{
id:"showDrill",
name:"showDrill",
text:"Show Drill",
checked:true
},{
id:"showFilter",
name:"showFilter",
text:"show Filter",
checked:true
},{
id:"showMissing",
name:"showMissing",
text:"Show Missing",
checked:true
},{
id:"showToolTip",
name:"showToolTip",
text:"show ToolTip",
checked:true
},{
id:"mergeItem",
name:"mergeItem",
text:"Merge Item",
checked:false
},{
id:"showHeaders",
name:"showHeaders",
text:"showHeaders",
checked:true
}]);
const grandTotalPosition = shallowRef(3);
const subtotalsPosition = shallowRef(2);
const displayFieldsInPageFilterArea = shallowRef(1);
const missingCaption = shallowRef("");
const rowLabelIndent = shallowRef(0);
const pivotTableLayout = shallowRef(1);
const reportFilterFieldsPerColumn = shallowRef(1);
function initSpread(spread) {
spreadRef.value = spread;
spread.suspendPaint();
spread.setSheetCount(2);
let sheet1 = spread.getSheet(0);
let sheet2 = spread.getSheet(1);
let tableName = getDataSource(sheet2, pivotSales);
initPivotTable(sheet1, tableName);
spread.resumePaint();
}
function getDataSource(sheet, tableSource) {
sheet.name("DataSource");
sheet.setRowCount(117);
sheet.setColumnWidth(0, 120);
sheet.getCell(-1, 0).formatter("YYYY-mm-DD");
sheet.getRange(-1,4,0,2).formatter("$ #,##0");
let table = sheet.tables.add('table', 0, 0, 117, 6);
for(let i=2;i<=117;i++)
{
sheet.setFormula(i-1,5,'=D'+i+'*E'+i)
}
table.style(GC.Spread.Sheets.Tables.TableThemes["none"]);
sheet.setArray(0, 0, tableSource);
return table.name();
}
function initPivotTable(sheet, tableName) {
sheet.name("PivotTable");
sheet.setRowCount(1000);
let option = {
bandRows:true,
bandColumns:true
};
let pivotTable = sheet.pivotTables.add("pivotTable", tableName, 1, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.medium8,option);
pivotTable.suspendLayout();
pivotTable.add("quantity", "Quantity", GC.Spread.Pivot.PivotTableFieldType.filterField);
pivotTable.add("price", "Price", GC.Spread.Pivot.PivotTableFieldType.filterField);
pivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField);
pivotTable.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.rowField);
let groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] };
pivotTable.group(groupInfo);
pivotTable.add("Quarters (date)", "Quarters (date)", GC.Spread.Pivot.PivotTableFieldType.columnField);
pivotTable.add("total", "Totals", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
let style = new GC.Spread.Sheets.Style();
style.formatter = "$ #,##0";
pivotTable.setStyle({dataOnly: true}, style);
pivotTable.resumeLayout();
pivotTable.autoFitColumn();
}
function updatePivotOption () {
let spread = spreadRef.value;
spread.suspendPaint();
let pivotTable = spread.getActiveSheet().pivotTables.get("pivotTable");
pivotTable.suspendLayout();
let option = pivotTable.options;
let optionValue = items.value;
for (let i = 0; i < optionValue.length; i++) {
option[optionValue[i].name] = optionValue[i].checked;
}
option["grandTotalPosition"] = grandTotalPosition.value;
option["subtotalsPosition"] = subtotalsPosition.value;
option["displayFieldsInPageFilterArea"] = displayFieldsInPageFilterArea.value;
option["reportFilterFieldsPerColumn"] = reportFilterFieldsPerColumn.value;
if (!isNaN(parseFloat(missingCaption.value))) {
option["missingCaption"] = parseFloat(missingCaption.value);
} else {
option["missingCaption"] = missingCaption.value;
}
if (!isNaN(parseFloat(rowLabelIndent.value))) {
option["rowLabelIndent"] = parseFloat(rowLabelIndent.value);
}
pivotTable.layoutType(+pivotTableLayout.value);
pivotTable.resumeLayout();
spread.resumePaint();
}
return {
initSpread,
items,
grandTotalPosition,
subtotalsPosition,
displayFieldsInPageFilterArea,
missingCaption,
rowLabelIndent,
pivotTableLayout,
reportFilterFieldsPerColumn,
updatePivotOption
}
}
}
</script>
<style scoped>
#app {
height: 100%;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 300px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 300px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
font-size: 14px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
.set-option {
display: block;
margin-top: 20px;
width: 250px;
}
#reportFilterFieldsPerColumn {
width: 28px;
}
.select-option-class{
display: block;
margin-top: 20px;
margin-bottom: 10px
}
.select-option-select{
width: 250px;
display: block;
margin-bottom: 20px;
}
.option-item{
height: 20px;
margin-bottom: 10px;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'../node_modules/*/package.json',
"../node_modules/@mescius/*/package.json",
"../node_modules/@babel/*/package.json",
"../node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-en': 'npm:@mescius/spread-sheets-resources-en/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js',
'@mescius/spread-sheets-pivot-addon': 'npm:@mescius/spread-sheets-pivot-addon/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js'
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

You can configure the PivotTable with different parameters:
These parameters that can be used for PivotTable are as follows:
allowMultipleFiltersPerField: whether multiple filters can be used in one field.
insertBlankLineAfterEachItem: whether a blank row should be inserted at end of each item.
grandTotalPosition: show the grandtotal in the row, column or both.
subtotalsPosition: show subtotal top, bottom, or not.
displayFieldsInPageFilterArea: display the page area fields first over then down or first down then over
reportFilterFieldsPerColumn: the number of report filter fields per column
bandRows: show banded rows or not
bandColumns: show banded columns or not
showRowHeader: show row header styles or not
showColumnHeader: show column header styles or not
showDrill: show expand/collapse button or not
showMissing: show missing caption or not
showToolTip: show tool tip or not
missingCaption: replace empty cell in content area to custom string or number
fillDownLabels: show repeat label items or not
repeatAllItemLabels: show repeat label items or not
rowLabelIndent: set the indent of each level of title in compact layout
mergeItem: merge and center cells with labels
showHeaders: show row and column headers or not
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
ReactDOM.render(<AppFunc />, document.getElementById('app'));
// 2. Class Component sample
// ReactDOM.render(<App />, document.getElementById('app'));
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-pivot-addon";
import { SpreadSheets } from '@mescius/spread-sheets-react';
import './styles.css';
const useState = React.useState;
function PivotOption(props) {
return (<div className="option-item">
<input type="checkbox" id={props.value} name={props.value} value={props.value} class="select-option" checked={props.checked} onChange={props.onChange}></input>
<label for={props.value}>{props.text}</label>
</div>);
}
export function AppFunc() {
const [pivotTable, setPivotTable] = useState(null);
const [state, setState] = useState({
option: {
allowMultipleFiltersPerField: false,
insertBlankLineAfterEachItem: false,
fillDownLabels: false,
bandRows: true,
bandColumns: true,
showRowHeader: true,
showColumnHeader: true,
showDrill: true,
showFilter: true,
showMissing: true,
showToolTip: true,
mergeItem: false,
showHeaders: true
},
grandTotalPosition: 3,
displayFieldsInPageFilterArea: 1,
subtotalsPosition: 2,
pivotTableLayout: 1,
missingCaption: null,
reportFilterFieldsPerColumn: 1,
rowLabelIndent: null
});
const handleSetOption = () => {
pivotTable.suspendLayout();
let actualOption = state.option;
let option = pivotTable.options, item;
for (item in actualOption) {
if (Object.prototype.hasOwnProperty.call(actualOption, item)) {
option[item] = actualOption[item];
}
}
option["grandTotalPosition"] = parseInt(state.grandTotalPosition, 10);
option["subtotalsPosition"] = parseInt(state.subtotalsPosition, 10);
option["displayFieldsInPageFilterArea"] = parseInt(state.displayFieldsInPageFilterArea, 10);
option["reportFilterFieldsPerColumn"] = state.reportFilterFieldsPerColumn;
let rowLabelIndent = state.rowLabelIndent;
let missingCaption = state.missingCaption;
option["missingCaption"] = state.missingCaption;
if (!isNaN(parseFloat(missingCaption))) {
option["missingCaption"] = parseFloat(missingCaption);
} else {
option["missingCaption"] = missingCaption;
}
if (!isNaN(parseFloat(rowLabelIndent))) {
option["rowLabelIndent"] = parseFloat(rowLabelIndent);
}
pivotTable.layoutType(+state.pivotTableLayout);
pivotTable.resumeLayout();
}
const handleInputClick = (event) => {
const target = event.target;
const value = target.checked;
const name = target.name;
let option = { ...state.option, [name]: value };
setState((state) => ({
...state, option
}));
}
const handleInputChange = (event) => {
const target = event.target;
const value = target.value;
const name = target.name;
setState((state) => ({
...state,
[name]: value
}));
}
const initSpread = (spread) => {
spread.suspendPaint();
spread.setSheetCount(2);
let sheet1 = spread.getSheet(0);
let sheet2 = spread.getSheet(1);
let tableName = getDataSource(sheet2, pivotSales);
let pt = initPivotTable(sheet1, tableName);
setPivotTable(pt);
spread.resumePaint();
}
const getDataSource = (sheet, tableSource) => {
sheet.name("DataSource");
sheet.setRowCount(117);
sheet.setColumnWidth(0, 120);
sheet.getCell(-1, 0).formatter("YYYY-mm-DD");
sheet.getRange(-1, 4, 0, 2).formatter("$ #,##0");
let table = sheet.tables.add('table', 0, 0, 117, 6);
for (let i = 2; i <= 117; i++) {
sheet.setFormula(i - 1, 5, '=D' + i + '*E' + i)
}
table.style(GC.Spread.Sheets.Tables.TableThemes["none"]);
sheet.setArray(0, 0, tableSource);
return table.name();
}
const initPivotTable = (sheet, source) => {
sheet.name("PivotTable");
sheet.setRowCount(1000);
let option = {
bandRows: true,
bandColumns: true
};
let pt = sheet.pivotTables.add("pivotTable", source, 1, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.medium8, option);
pt.suspendLayout();
pt.add("quantity", "Quantity", GC.Spread.Pivot.PivotTableFieldType.filterField);
pt.add("price", "Price", GC.Spread.Pivot.PivotTableFieldType.filterField);
pt.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField);
pt.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.rowField);
let groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] };
pt.group(groupInfo);
pt.add("Quarters (date)", "Quarters (date)", GC.Spread.Pivot.PivotTableFieldType.columnField);
pt.add("total", "Totals", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
let style = new GC.Spread.Sheets.Style();
style.formatter = "$ #,##0";
pt.setStyle({ dataOnly: true }, style);
pt.resumeLayout();
pt.autoFitColumn();
return pt;
}
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
</SpreadSheets>
</div>
<div id="container" class="options-container">
<div class="option-item">
<label><b>Pivot Options</b></label>
</div>
<hr />
<PivotOption value={'allowMultipleFiltersPerField'} text="Allow Multiple Filters Per Field" checked={state.option.allowMultipleFiltersPerField} onChange={handleInputClick}></PivotOption>
<PivotOption value={'insertBlankLineAfterEachItem'} text="Insert Blank Line After Each Item" checked={state.option.insertBlankLineAfterEachItem} onChange={handleInputClick}></PivotOption>
<PivotOption value={'fillDownLabels'} text="fillDownLabels" checked={state.option.fillDownLabels} onChange={handleInputClick}></PivotOption>
<PivotOption value={'bandRows'} text="Band Rows" checked={state.option.bandRows} onChange={handleInputClick}></PivotOption>
<PivotOption value={'bandColumns'} text="Band Columns" checked={state.option.bandColumns} onChange={handleInputClick}></PivotOption>
<PivotOption value={'showRowHeader'} text="Show Row Header" checked={state.option.showRowHeader} onChange={handleInputClick}></PivotOption>
<PivotOption value={'showColumnHeader'} text="Show Column Header" checked={state.option.showColumnHeader} onChange={handleInputClick}></PivotOption>
<PivotOption value={'showDrill'} text="Show Drill" checked={state.option.showDrill} onChange={handleInputClick}></PivotOption>
<PivotOption value={'showFilter'} text="Show Filter" checked={state.option.showFilter} onChange={handleInputClick}></PivotOption>
<PivotOption value={'showMissing'} text="Show Missing" checked={state.option.showMissing} onChange={handleInputClick}></PivotOption>
<PivotOption value={'showToolTip'} text="Show ToolTip" checked={state.option.showToolTip} onChange={handleInputClick}></PivotOption>
<PivotOption value={'mergeItem'} text="Merge Item" checked={state.option.mergeItem} onChange={handleInputClick}></PivotOption>
<PivotOption value={'showHeaders'} text="showHeaders" checked={state.option.showHeaders} onChange={handleInputClick}></PivotOption>
<hr />
<div>
<div class="select-option-class">Grand Total Position:</div>
<select value={state.grandTotalPosition} name="grandTotalPosition" id="grandTotalPosition" class="grandTotalPosition select-option-select" onChange={handleInputChange}>
<option value="0">none</option>
<option value="1">row</option>
<option value="2">col</option>
<option value="3">both</option>
</select>
</div>
<div>
<div class="select-option-class">Subtotals Position:</div>
<select value={state.subtotalsPosition} name="subtotalsPosition" id="subtotalsPosition" class="subtotalsPosition select-option-select" onChange={handleInputChange}>
<option value="2">bottom</option>
<option value="0">none</option>
<option value="1">top</option>
</select>
</div>
<div>
<div class="select-option-class">Display Fields In Page Filter Area:</div>
<select value={state.displayFieldsInPageFilterArea} name="displayFieldsInPageFilterArea" id="displayFieldsInPageFilterArea" class="displayFieldsInPageFilterArea select-option-select" onChange={handleInputChange}>
<option value="1">overThenDown</option>
<option value="0">downThenOver</option>
</select>
</div>
<div>
<div class="select-option-class">PivotTable Layout:</div>
<select id="pivotTableLayout" class="pivotTableLayout select-option-select" name="pivotTableLayout" value={state.pivotTableLayout} onChange={handleInputChange}>
<option value="0">Compact</option>
<option value="1">Outline</option>
<option value="2">Tabular</option>
</select>
</div>
<div>
<div class="select-option-class">Show Empty Value In Content Area As:</div>
<input type="text" name="missingCaption" id="missingCaption" class="missingCaption select-option-select" value={state.missingCaption} onChange={handleInputChange} />
</div>
<div>
<div class="select-option-class">Set Row Label Indent In Compact Layout:</div>
<input type="number" name="rowLabelIndent" id="rowLabelIndent" class="rowLabelIndent select-option-select" value={state.rowLabelIndent} onChange={handleInputChange} />
</div>
<div>
<label for="reportFilterFieldsPerColumn">Report Filter Fields Per Column:</label>
<input type="number" name="reportFilterFieldsPerColumn" id="reportFilterFieldsPerColumn" min="1" value={state.reportFilterFieldsPerColumn} onChange={handleInputChange}></input>
</div>
<input type="button" value="Apply" class="set-option" id="set-option" onClick={handleSetOption}></input>
</div>
</div>
);
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-pivot-addon";
import { SpreadSheets } from '@mescius/spread-sheets-react';
import './styles.css';
const Component = React.Component;
function PivotOption(props) {
return (<div className="option-item">
<input type="checkbox" id={props.value} name={props.value} value={props.value} class="select-option" checked={props.checked} onChange={props.onChange}></input>
<label for={props.value}>{props.text}</label>
</div>);
}
export class App extends Component {
constructor(props) {
super(props);
this.state = {
renderChild: false,
option: {
allowMultipleFiltersPerField: false,
insertBlankLineAfterEachItem: false,
fillDownLabels: false,
bandRows: true,
bandColumns: true,
showRowHeader: true,
showColumnHeader: true,
showDrill: true,
showFilter: true,
showMissing: true,
showToolTip: true,
mergeItem: false,
showHeaders: true
},
grandTotalPosition: 3,
displayFieldsInPageFilterArea: 1,
subtotalsPosition: 2,
pivotTableLayout: 1,
missingCaption: null,
reportFilterFieldsPerColumn: 1,
rowLabelIndent: null
}
this.handleSetOption = this.handleSetOption.bind(this);
this.handleInputChange = this.handleInputChange.bind(this);
this.handleInputClick = this.handleInputClick.bind(this);
}
handleSetOption() {
let pivotTable = this.pivotTable;
let state = this.state;
pivotTable.suspendLayout();
let actualOption = state.option;
let option = pivotTable.options, item;
for (item in actualOption) {
if (Object.prototype.hasOwnProperty.call(actualOption, item)) {
option[item] = actualOption[item];
}
}
option["grandTotalPosition"] = parseInt(state.grandTotalPosition, 10);
option["subtotalsPosition"] = parseInt(state.subtotalsPosition, 10);
option["displayFieldsInPageFilterArea"] = state.displayFieldsInPageFilterArea;
option["reportFilterFieldsPerColumn"] = state.reportFilterFieldsPerColumn;
let rowLabelIndent = state.rowLabelIndent;
let missingCaption = state.missingCaption;
option["missingCaption"] = state.missingCaption;
if (!isNaN(parseFloat(missingCaption))) {
option["missingCaption"] = parseFloat(missingCaption);
} else {
option["missingCaption"] = missingCaption;
}
if (!isNaN(parseFloat(rowLabelIndent))) {
option["rowLabelIndent"] = parseFloat(rowLabelIndent);
}
pivotTable.layoutType(+state.pivotTableLayout);
pivotTable.resumeLayout();
}
handleInputClick(event) {
const target = event.target;
const value = target.checked;
const name = target.name;
let option = this.state.option;
option[name] = value;
this.setState({
option
});
}
handleInputChange(event) {
const target = event.target;
const value = target.value;
const name = target.name;
this.setState({
[name]: value
});
}
render() {
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
</SpreadSheets>
</div>
<div id="container" class="options-container">
<div class="option-item">
<label><b>Pivot Options</b></label>
</div>
<hr />
<PivotOption value={'allowMultipleFiltersPerField'} text="Allow Multiple Filters Per Field" checked={this.state.option.allowMultipleFiltersPerField} onChange={this.handleInputClick}></PivotOption>
<PivotOption value={'insertBlankLineAfterEachItem'} text="Insert Blank Line After Each Item" checked={this.state.option.insertBlankLineAfterEachItem} onChange={this.handleInputClick}></PivotOption>
<PivotOption value={'fillDownLabels'} text="fillDownLabels" checked={this.state.option.fillDownLabels} onChange={this.handleInputClick}></PivotOption>
<PivotOption value={'bandRows'} text="Band Rows" checked={this.state.option.bandRows} onChange={this.handleInputClick}></PivotOption>
<PivotOption value={'bandColumns'} text="Band Columns" checked={this.state.option.bandColumns} onChange={this.handleInputClick}></PivotOption>
<PivotOption value={'showRowHeader'} text="Show Row Header" checked={this.state.option.showRowHeader} onChange={this.handleInputClick}></PivotOption>
<PivotOption value={'showColumnHeader'} text="Show Column Header" checked={this.state.option.showColumnHeader} onChange={this.handleInputClick}></PivotOption>
<PivotOption value={'showDrill'} text="Show Drill" checked={this.state.option.showDrill} onChange={this.handleInputClick}></PivotOption>
<PivotOption value={'showFilter'} text="Show Filter" checked={this.state.option.showFilter} onChange={this.handleInputClick}></PivotOption>
<PivotOption value={'showMissing'} text="Show Missing" checked={this.state.option.showMissing} onChange={this.handleInputClick}></PivotOption>
<PivotOption value={'showToolTip'} text="Show ToolTip" checked={this.state.option.showToolTip} onChange={this.handleInputClick}></PivotOption>
<PivotOption value={'mergeItem'} text="Merge Item" checked={this.state.option.mergeItem} onChange={this.handleInputClick}></PivotOption>
<PivotOption value={'showHeaders'} text="showHeaders" checked={this.state.option.showHeaders} onChange={this.handleInputClick}></PivotOption>
<hr />
<div>
<div class="select-option-class">Grand Total Position:</div>
<select value={this.state.grandTotalPosition} name="grandTotalPosition" id="grandTotalPosition" class="grandTotalPosition select-option-select" onChange={this.handleInputChange}>
<option value="0">none</option>
<option value="1">row</option>
<option value="2">col</option>
<option value="3">both</option>
</select>
</div>
<div>
<div class="select-option-class">Subtotals Position:</div>
<select value={this.state.subtotalsPosition} name="subtotalsPosition" id="subtotalsPosition" class="subtotalsPosition select-option-select" onChange={this.handleInputChange}>
<option value="2">bottom</option>
<option value="0">none</option>
<option value="1">top</option>
</select>
</div>
<div>
<div class="select-option-class">Display Fields In Page Filter Area:</div>
<select value={this.state.displayFieldsInPageFilterArea} name="displayFieldsInPageFilterArea" id="displayFieldsInPageFilterArea" class="displayFieldsInPageFilterArea select-option-select" onChange={this.handleInputChange}>
<option value="1">overThenDown</option>
<option value="0">downThenOver</option>
</select>
</div>
<div>
<div class="select-option-class">PivotTable Layout:</div>
<select id="pivotTableLayout" class="pivotTableLayout select-option-select" name="pivotTableLayout" value={this.state.pivotTableLayout} onChange={this.handleInputChange}>
<option value="0">Compact</option>
<option value="1">Outline</option>
<option value="2">Tabular</option>
</select>
</div>
<div>
<div class="select-option-class">Show Empty Value In Content Area As:</div>
<input type="text" name="missingCaption" id="missingCaption" class="missingCaption select-option-select" value={this.state.missingCaption} onChange={this.handleInputChange} />
</div>
<div>
<div class="select-option-class">Set Row Label Indent In Compact Layout:</div>
<input type="number" name="rowLabelIndent" id="rowLabelIndent" class="rowLabelIndent select-option-select" value={this.state.rowLabelIndent} onChange={this.handleInputChange} />
</div>
<div>
<label for="reportFilterFieldsPerColumn">Report Filter Fields Per Column:</label>
<input type="number" name="reportFilterFieldsPerColumn" id="reportFilterFieldsPerColumn" min="1" value={this.state.reportFilterFieldsPerColumn} onChange={this.handleInputChange}></input>
</div>
{this.state.renderChild ? <input type="button" value="Apply" class="set-option" id="set-option" onClick={this.handleSetOption}></input> : ""}
</div>
</div>
);
}
initSpread(spread) {
spread.suspendPaint();
spread.setSheetCount(2);
let sheet1 = spread.getSheet(0);
let sheet2 = spread.getSheet(1);
let tableName = this.getDataSource(sheet2, pivotSales);
let pivotTable = this.initPivotTable(sheet1, tableName);
this.pivotTable = pivotTable;
spread.resumePaint();
}
componentDidMount() {
this.setState(() => ({
renderChild: true
}))
}
getDataSource(sheet, tableSource) {
sheet.name("DataSource");
sheet.setRowCount(117);
sheet.setColumnWidth(0, 120);
sheet.getCell(-1, 0).formatter("YYYY-mm-DD");
sheet.getRange(-1, 4, 0, 2).formatter("$ #,##0");
let table = sheet.tables.add('table', 0, 0, 117, 6);
for (let i = 2; i <= 117; i++) {
sheet.setFormula(i - 1, 5, '=D' + i + '*E' + i)
}
table.style(GC.Spread.Sheets.Tables.TableThemes["none"]);
sheet.setArray(0, 0, tableSource);
return table.name();
}
initPivotTable(sheet, source) {
sheet.name("PivotTable");
sheet.setRowCount(1000);
let option = {
bandRows: true,
bandColumns: true
};
let pivotTable = sheet.pivotTables.add("pivotTable", source, 1, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.medium8, option);
pivotTable.suspendLayout();
pivotTable.add("quantity", "Quantity", GC.Spread.Pivot.PivotTableFieldType.filterField);
pivotTable.add("price", "Price", GC.Spread.Pivot.PivotTableFieldType.filterField);
pivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField);
pivotTable.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.rowField);
let groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] };
pivotTable.group(groupInfo);
pivotTable.add("Quarters (date)", "Quarters (date)", GC.Spread.Pivot.PivotTableFieldType.columnField);
pivotTable.add("total", "Totals", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
let style = new GC.Spread.Sheets.Style();
style.formatter = "$ #,##0";
pivotTable.setStyle({ dataOnly: true }, style);
pivotTable.resumeLayout();
pivotTable.autoFitColumn();
return pivotTable;
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app" style="height: 100%;"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 300px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 300px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
.set-option {
display: block;
margin-top: 20px;
width: 250px;
}
#reportFilterFieldsPerColumn {
width: 28px;
}
.select-option-class{
display: block;
margin-top: 20px;
margin-bottom: 10px
}
.select-option-select{
width: 250px;
display: block;
margin-bottom: 20px;
}
.option-item{
height: 20px;
margin-bottom: 10px;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-pivot-addon': 'npm:@mescius/spread-sheets-pivot-addon/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/umd/react.production.min.js',
'react-dom': 'npm:react-dom/umd/react-dom.production.min.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);